#! /bin/sh
#
# /etc/init.d/autobench
#
#   Linux chkconfig stuff:
#
#   chkconfig: 2345 55 10
#   description: autobench

# Source function library.
if [ -f /etc/init.d/functions ] ; then
	. /etc/init.d/functions
elif [ -f /etc/rc.d/init.d/functions ] ; then
	. /etc/rc.d/init.d/functions
else
	exit 0
fi

AUTODIR=${AUTODIR:-/autobench}
. /etc/autobench_instances
. $MASTER_AUTODIR/etc/autobench.conf || . $AUTODIR/scripts/functions
AUTOBENCH_BIN=$AUTODIR/scripts/autobench
test -x $AUTOBENCH_BIN || exit 5
AUTORUN_BIN=$AUTODIR/scripts/autorun
test -x $AUTORUN_BIN || exit 5


case "$1" in
    start)
	if [ `uname -a | grep xen | wc -l` -gt 0 ]; then
	    echo -n "Starting xend"
	    /etc/init.d/xend start
	fi

	echo -n "Starting Autobench daemon"
	## Start daemon with startproc(8). If this fails
	## the echo return value is set appropriate.

	daemon $AUTOBENCH_BIN
        RETVAL=$?
	echo
	[ $RETVAL = 0 ] && touch /var/lock/subsys/cups
	;;
    stop)
	echo -n "Shutting down AUTOBENCH daemon"
	## Stop daemon with killproc(8) and if this fails
	## set echo the echo return value.
	killproc $AUTORUN_BIN
	RETVAL=$?
	echo
	[ $RETVAL = 0 ] && rm -f /var/lock/subsys/cups
	;;
    try-restart)
	## Stop the service and if this succeeds (i.e. the 
	## service was running before), start it again.
	## Note: try-restart is not (yet) part of LSB (as of 0.7.5)
	$0 status >/dev/null &&  $0 restart
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start
	;;
    force-reload)
	## Signal the daemon to reload its config. Most daemons
	## do this on signal 1 (SIGHUP).
	## If it does not support it, restart.
	echo -n "Reload service Autobench"
	checkproc $AUTORUN_BIN
	;;
    reload)
	## Like force-reload, but if daemon does not support
	## signalling, do nothing (!)

	## Otherwise if it does not support reload:
	rc_status -v
	;;
    status)
	echo -n "Checking for Autobench: "
	## Check status with checkproc(8), if process is running
	## checkproc will return with exit status 0.

	# Status has a slightly different for the status command:
	# 0 - service running
	# 1 - service dead, but /var/run/  pid  file exists
	# 2 - service dead, but /var/lock/ lock file exists
	# 3 - service not running

	# NOTE: checkproc returns LSB compliant status values.
	checkproc $AUTORUN_BIN
	rc_status -v
	;;
    probe)
	## Optional: Probe for the necessity of a reload,
	## give out the argument which is required for a reload.

	;;
    *)
	echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
	exit 1
	;;
esac
exit $RETVAL
